/**
 * Copyright Soramitsu Co., Ltd. 2017 All Rights Reserved.
 * http://soramitsu.co.jp
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef IROHA_CLI_TRANSACTION_RESPONSE_HANDLER_HPP
#define IROHA_CLI_TRANSACTION_RESPONSE_HANDLER_HPP

#include "client.hpp"  // for CliClient::TxStatus (yuck!)

namespace spdlog {
  class logger;
}

namespace iroha_cli {

  class TransactionResponseHandler {
   public:
    TransactionResponseHandler();
    /**
     * Handle response from Iroha
     * @param status of transaction
     */
    void handle(const CliClient::TxStatus status) const;

   private:
    std::shared_ptr<spdlog::logger> log_;
  };
}  // namespace iroha_cli

#endif  // IROHA_CLI_TRANSACTION_RESPONSE_HANDLER_HPP
