/**
 * Copyright Soramitsu Co., Ltd. 2017 All Rights Reserved.
 * http://soramitsu.co.jp
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "bindings/model_query_builder.hpp"

#include <gtest/gtest.h>

/**
 * @given Model transaction builder
 * @when build() is called on builder without set fields
 * @then Exception is thrown
 */
TEST(ModelQueryBuilderTest, EmptyBuilder) {
  auto query = shared_model::bindings::ModelQueryBuilder();

  EXPECT_ANY_THROW(query.build());
}
